"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const Pressable_1 = __importDefault(require("./Pressable"));
const StackX_1 = __importDefault(require("./Stack/StackX"));
const Text_1 = __importDefault(require("./Text"));
const Checkbox = (props, ref) => {
    const { backgroundColorActive, backgroundColor, children, isChecked, onChange, size, tickActiveColor, tickColor, } = props;
    const [checked, toggleChecked] = (0, react_1.useState)(false);
    // TODO: useColoredProps for this component
    // const coloredPropItems = useColoredProps(props);
    const onPress = (0, react_1.useCallback)(() => {
        onChange === null || onChange === void 0 ? void 0 : onChange(!checked);
        toggleChecked(!checked);
    }, [checked, onChange]);
    const isRealChecked = typeof isChecked === "boolean" ? isChecked : checked;
    const backgroundColorResult = isRealChecked
        ? backgroundColorActive || "#ecf8ff"
        : backgroundColor || "#fff";
    const iconSize = size !== null && size !== void 0 ? size : 18;
    const componentSize = iconSize * 1.5;
    const tickColorResult = isRealChecked
        ? tickActiveColor || "#000"
        : tickColor || "#000";
    const isString = typeof children === "string";
    return (react_1.default.createElement(Pressable_1.default, { ref: ref, onPress: onPress },
        react_1.default.createElement(StackX_1.default, { alignItems: 'center', space: 12 },
            react_1.default.createElement(StackX_1.default, { alignItems: 'center', justifyContent: 'center', borderWidth: 1, borderColor: '#b88b2d', borderRadius: 999, backgroundColor: backgroundColorResult, width: componentSize, height: componentSize }, isRealChecked && react_1.default.createElement(Text_1.default, { fontSize: iconSize }, "\u2713")),
            isString ? (react_1.default.createElement(Text_1.default, { color: tickColorResult, fontSize: 14 }, children)) : (children))));
};
exports.default = (0, react_1.memo)((0, react_1.forwardRef)(Checkbox));
