"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const utils_1 = require("../../utils");
const useColoredProps_1 = __importDefault(require("../../hooks/useColoredProps"));
const Stack = (0, react_1.forwardRef)((props, ref) => {
    const { children, pointerEvents, space, style } = props, restStyleProps = __rest(props, ["children", "pointerEvents", "space", "style"]);
    const coloredPropItems = (0, useColoredProps_1.default)(props);
    const computedProps = (0, react_1.useMemo)(() => (0, utils_1.mapShortStyleProps)(restStyleProps), [restStyleProps]);
    const isRow = !!(props.flexDirection && props.flexDirection.toLowerCase().indexOf('row') > -1);
    const childrens = (0, react_1.useMemo)(() => {
        if (typeof space === 'undefined') {
            return [children];
        }
        return getChildrenWithSpace(children, isRow, space);
    }, [children, isRow, space]);
    const isMore = childrens.length > 0;
    return (react_1.default.createElement(react_native_1.View, { ref: ref, pointerEvents: pointerEvents, style: [style, ...computedProps, ...coloredPropItems] }, isMore ? childrens : children));
});
function getChildrenWithSpace(children, isRow, space) {
    const Childs = react_1.Children.toArray(children);
    const childrens = Childs.map((child, i) => {
        const marginLeft = isRow
            ? i <= Childs.length - 1 && i !== 0
                ? +space / 2
                : undefined
            : undefined;
        const marginRight = isRow
            ? i < Childs.length - 1
                ? +space / 2
                : undefined
            : undefined;
        const marginTop = isRow
            ? undefined
            : i <= Childs.length - 1 && i !== 0
                ? +space / 2
                : undefined;
        const marginBottom = isRow
            ? undefined
            : i < Childs.length - 1
                ? +space / 2
                : undefined;
        const style = {
            marginLeft,
            marginTop,
            marginRight,
            marginBottom,
        };
        return (react_1.default.createElement(react_native_1.View, { style: style, key: i }, child));
    });
    return childrens;
}
exports.default = (0, react_1.memo)(Stack);
